local RM=LibStub("AceAddon-3.0"):GetAddon("Raid Mover");

function RM:saveLayout(name, layout)
	profileDB.layouts[name] = {}
	profileDB.layouts[name] = layout
end

function RM:removeLayout(layout)
	if profileDB.layouts[layout] then
		profileDB.layouts[layout] = nil;
		if not profileDB.layouts[layout] then
			RM:Print(layout.." has been removed!");
		else
			RM:Print("ERROR: "..layout.." was NOT removed!");
		end
	else
		RM:Print(layout.." does not exist!");
	end
	RM:runSaves();
end

function RM:createLayout(layout)
	if not profileDB.layouts[layout] then
		profileDB.layouts[layout] = {};
		if profileDB.layouts[layout] then
			RM:Print(layout.." created successfully!")
		end
	else
		RM:Print(layout.." already exists!");
	end
	RM:runSaves();
end

function RM:copyLayout(layoutname, copyname)
	if profileDB.layouts[layoutname] and not profileDB.layouts[copyname] then
		profileDB.layouts[copyname] = RM:deepCopy(profileDB.layouts[layoutname], {});
	elseif not profileDB.layouts[layoutname] then
		RM:Print("The layout "..layoutname.." does not exist.");
	else
		RM:Print("A saved layout with the name "..copyname.." already exists.");
	end
	RM:runSaves();
end

function RM:renameLayout(layoutname, newname)
	if layoutname and newname and layoutname == newname then 
		RM:Print("ERROR: That is the same name!")
	elseif layoutname and newname and profileDB.layouts[layoutname] and not profileDB.layouts[copyname] then
		profileDB.layouts[newname] = RM:deepCopy(profileDB.layouts[layoutname], {});
		profileDB.layouts[layoutname] = nil;
		RM:Print("Successfully renamed "..layoutname.." to "..newname);
	elseif not profileDB.layouts[layoutname] then
		RM:Print("ERROR: The layout "..layoutname.." does not exist.");
	elseif profileDB.layouts[copyname] then
		RM:Print("ERROR: A saved layout with the name "..newname.." already exists.");
	else
		RM:Print("ERROR: Invalid arguments.");
	end	
	RM:runSaves();
end

function RM:printLayout(layout)
	local output = "";
	if layout then
		if profileDB.layouts[layout] then
			for i=1, 8 do
				local header = 1;
				for pname, ptable in pairs(profileDB.layouts[layout]) do
					if profileDB.layouts[layout][pname].subgrp == i then
						if header == 1 then
							--DEBUG: RM:Print("--------- GROUP "..i.." ---------");
							output = output.."--------- GROUP "..i.." ---------\n";
							header = 0;
						end
						--DEBUG: RM:Print("          "..tostring(pname));
						output = output.."          "..tostring(pname).."\n";
					end
				end
			end
		else
			RM:Print(layout.." does not exist.");
		end
	else
		RM:Print("Invalid saved name.");
	end
	return output;
end

function RM:exportLayout(layoutname)
	local exportstring = "["..layoutname.."]\n"
	for i=1,8 do
		for pname, ptable in pairs(profileDB.layouts[layoutname]) do
			if profileDB.layouts[layoutname][pname].subgrp==i then
				exportstring = exportstring..pname..profileDB.layouts[layoutname][pname].subgrp..profileDB.layouts[layoutname][pname].class..",\n"
			end
		end
	end
	return exportstring
end

function RM:importLayout(importtext, layoutname)
	local layoutnamestring = "Added: "
	local testtext = importtext
	--Remove whitespace
	testtext = string.gsub(testtext, "%s+", "")
	testtext = string.gsub(testtext, "\n+", "")
	--RM:Print(testtext)
	
	function find_layoutname(text)
		if #text>0 then
			local startindex = string.find(string.sub(text, 1, 2), "%[")
			if startindex then
				local endindex = string.find(text, "%]")
				--RM:Print(string.sub(text, startindex+1, endindex-1))
				profileDB.layouts[string.sub(text, startindex+1, endindex-1)]={}
				layoutname = string.sub(text, startindex+1, endindex-1)
				layoutnamestring = layoutnamestring..layoutname..", "
				--find_player(string.sub(text, endindex+2))
				find_player(string.sub(text, endindex+1))
			else
				find_player(string.sub(text,1))
			end
		end
	end

	function find_player(text)
		local foundindex = string.find(text, ",")
		if foundindex then
			local numberindex = string.find(text, "%d+")
			--RM:Print(string.sub(text, 1, numberindex-1)..string.sub(text, numberindex, numberindex)..string.sub(text, numberindex+1, foundindex-1))
			profileDB.layouts[layoutname][string.sub(text, 1, numberindex-1)]={}
			profileDB.layouts[layoutname][string.sub(text, 1, numberindex-1)].subgrp=tonumber(string.sub(text, numberindex, numberindex))
			if string.sub(text, numberindex+1, foundindex-1)=="DeathKnight" then
				profileDB.layouts[layoutname][string.sub(text, 1, numberindex-1)].class="Death Knight"
			else
				profileDB.layouts[layoutname][string.sub(text, 1, numberindex-1)].class=string.sub(text, numberindex+1, foundindex-1)
			end
			--find_layoutname(string.sub(text, foundindex+2))
			find_layoutname(string.sub(text, foundindex+1))
		end
	end
	
	if layoutname then
		profileDB.layouts[layoutname] = {};
		find_player(testtext)
		RM:Print(layoutnamestring..layoutname)
	else
		find_layoutname(testtext)
		RM:Print(layoutnamestring)
	end
	RM:runSaves();
	return(layoutname);
end